#ifndef _fencer_hash_map_h
#define _fencer_hash_map_h

#include "list.h"
#include "stdint.h"

typedef struct Dictionary {
    List list;
    size_t element_size;
} Dictionary;

extern Dictionary dictionary_new(size_t element_size);
extern void* dictionary_get(Dictionary* self, const char* key);
extern int dictionary_set_raw(Dictionary* self, const char* key, void* data);
extern int dictionary_erase(Dictionary* self, const char* key);
extern void dictionary_empty(Dictionary* self);

static inline int dictionary_set_int(Dictionary* self, const char* key, int data) {
    return dictionary_set_raw(self, key, &data);
}
static inline int dictionary_set_unintptr(Dictionary* self, const char* key, uintptr_t data) {
    return dictionary_set_raw(self, key, &data);
}
#define dictionary_set_value(Type_, Dict_, Key_, Value_)\
{ Type_ __value = (Type_)Value_; dictionary_set_raw(Dict_, Key_, &__value); }
#define dictionary_check_size(Type_, Dict_)\
(Dict_)->element_size == sizeof(Type_)

#define dictionary_from_type(Type_)\
dictionary_new(sizeof(Type_))
#define dictionary_get_as(Type_, Dict_, Key_)\
(Type_*)dictionary_get(Dict_, Key_)
#define dictionary_get_value(Type_, Dict_, Key_)\
*((Type_*)dictionary_get(Dict_, Key_))

#endif // !_fencer_hash_map_h
